<?php

// --------------------------------------------------------------//
// Written by: Ben Nelson (Venom)                                //
// Last Modified: 03/14/2000                                     //
// Contact Info: venom@venom600.org                              //
//               www.venom600.org                                //
// --------------------------------------------------------------//
// This file contains all of the work functions needed for my    //
// web forum implementation.  I decided to write this forum      //
// because I wanted a forum on my website written in php. I was  //
// unable to find a decent forum implemented in php.  I also     //
// wanted my forum to run on a database system, rather than a    //
// forum that keeps its messages in separate files. Below is some//
// information that is specific to this forum.                   //
// --------------------------------------------------------------//
// PHP version: 3.0.14                                           //
// Apache Version: 1.3.6                                         //
// SQL system: MySQL 3.22.32                                     //
// --------------------------------------------------------------//

require( "db_misc.php3" );

// --------------------------------------------------------------//
//              print_item( $number, $no_spaces )                //
// --------------------------------------------------------------//
// This method recursively prints out all of the elements beneath//
// itself.                                                       //
// $number = id_num of a post to print                           //
// $no_spaces = number of spaces to print out in front of a      //
//              listing to make threading line up.               //
// --------------------------------------------------------------//
function print_item( $number, $no_spaces ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form the initial query
  $query = "select topic_id,subject,name,create_date";
  $query .= " from posts";
  $query .= " where topic_id = $number";
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked :)
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }


  // Print the proper number of spaces, to make threading look nice
  for( $i = 0; $i < $no_spaces; $i++ ) {
    printf( "&nbsp;" );
  }

  // Get the results of the query and parse the date
  list( $topic_id, $subject, $name, $create_date ) = mysql_fetch_row( $res );
  $printable_date = parse_date( $create_date );

  // Print Subject, name and date
  $subject = stripslashes( $subject );
  $name = stripslashes( $name );
  printf( "- <a href=\"post.php3?topic_id=$topic_id\">$subject</a>" );
  printf( " - posted by $name on $printable_date<br>\n" );

  // Form a new query
  $query = "select topic_id";
  $query .= " from posts";
  $query .= " where parent_id = $number";
  $query .= " order by create_date desc";

  // Send the query to the database
  $res = mysql_query( $query, $dbh );

  // Again, make sure it worked :)
  if(!$res) {
    db_err($dbh, "mysql_query: " . $query);
  }

  // Find out how many rows we are talking about here
  $nr = mysql_numrows($res);

  // Print out post listings for each in number of rows
  if( $nr > 0 ) {
    while( list( $topic_id2 ) = mysql_fetch_row( $res ) ) {
      print_item( $topic_id2, ($no_spaces + 5) );
    }
  }
}

// --------------------------------------------------------------//
//                          print_list()                         //
// --------------------------------------------------------------//
// This method starts the process of printing all of the posts.  //
// --------------------------------------------------------------//
function print_list( $number ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form a query to send to the db backend
  $query = "select topic_id";
  $query .= " from posts";
  $query .= " where parent_id = $number";
  $query .= " order by create_date desc";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  $nr = mysql_numrows( $res );

  if( $nr == 0 ) {
    $return_value = 0;
  } else {
    $return_value = 1;
    while( list( $id ) = mysql_fetch_row( $res ) ) {
      print_item( $id, 0 );
    }
  }
  return( $return_value );
}

// --------------------------------------------------------------//
//                              parse_date()                     //
// --------------------------------------------------------------//
// This method parses out a mysql time stamp into something      //
// readable by humans. :)                                        //
// --------------------------------------------------------------//
function parse_date( $in_date ) {
  $out_date = $in_date[4];
  $out_date .= $in_date[5];
  $out_date .= "/";
  $out_date .= $in_date[6];
  $out_date .= $in_date[7];
  $out_date .= "/";
  $out_date .= $in_date[0];
  $out_date .= $in_date[1];
  $out_date .= $in_date[2];
  $out_date .= $in_date[3];
  $out_date .= " at ";
  $out_date .= $in_date[8];
  $out_date .= $in_date[9];
  $out_date .= ":";
  $out_date .= $in_date[10];
  $out_date .= $in_date[11];

  return( $out_date );
}

// --------------------------------------------------------------//
//                  truncate_entry()                             //
// --------------------------------------------------------------//
// This method truncates a string after the specified number of  //
// characters.                                                   //
// --------------------------------------------------------------//
function truncate_entry( $entry, $num ) {
  $return_value = substr( $entry, 0, $num );

  return( $return_value );
}

// --------------------------------------------------------------//
//                           print_post()                        //
// --------------------------------------------------------------//
// This method prints out the entire post and all of its useful  //
// information.                                                  //
// --------------------------------------------------------------//
function print_post( $id ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form a query to get the post information
  $query = "select name,subject,message,create_date,hostname,host_ip,computer_info";
  $query .= " from posts where topic_id = $id";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  list( $name, $subject, $message, $create_date, $hostname, $host_ip, $computer_info ) = mysql_fetch_row( $res );
  $printable_date = parse_date( $create_date );

  // Form a query to get the config information
  $query = "select * from config where forum_id = 0";

  // Send the query to the backend
  $config_res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  // Get the results of the config query
  list( $forum_id, $all_html, $pre, $links, $images, $show_ip, $show_info, $block_hosts ) = mysql_fetch_row( $config_res );

  printf( "<table width=600 border=0 cellspacing=0 cellpadding=0>\n" );
  printf( "<tr>\n" );
  $subject = stripslashes( $subject );
  printf( "  <td align=right><b><font size=+3>Subject : </b></font></td><td align=left><font size=+3>$subject</font></td>" );
  printf( "\n</tr><tr>\n" );
  $name = stripslashes( $name );
  printf( "  <td align=right><b>Posted By : </b></td><td align=left>$name</td>" );
  printf( "\n</tr><tr>\n" );
  printf( "  <td align=right><b>Posted On : </b></td><td align=left>$printable_date</td>" );
  printf( "\n</tr>" );

  // Make sure we're allowed to show the posters IP/Hostname
  if( $show_ip == 'YES' ) {
    printf( "<tr>\n" );
    printf( "  <td align=right><b>Poster's Hostname/IP : </b></td><td align=lef>$hostname ($host_ip)</td>" );
    printf( "\n</tr>" );
  }

  // Make sure we're allowed to show the posters computer info
  if( $show_info == 'YES' ) {
    printf( "<tr>\n" );
    printf( "  <td align=right><b>Poster's Browser/System Type : </b></td><td align=left>$computer_info</td>" );
    printf( "\n</tr>" );
  }
  printf( "</table>\n" );
  printf( "<hr>\n" );
  printf( "<center><a href=\"/forum\">Forum Home</a> | <a href=\"/forum/faq.php3\">Forum FAQ</a></center>\n" );
  printf( "<hr>\n<br>\n" );
  printf( "<table width=550 border=0 cellspacing=0 cellpadding=0 align=center>\n" );
  $temp_message = stripslashes( $message );
  printf( "<tr><td>$temp_message</td></tr>\n" );
  printf( "</table>" );
  printf( "<br><hr><br>\n" );
}

// --------------------------------------------------------------//
//                         add_post()                            //
// --------------------------------------------------------------//
// This method adds a post to the database. Pretty straighforward//
// --------------------------------------------------------------//
function add_post( $parent, $root, $name, $subject, $message, $host, $hostip, $comp_info ) {
  $dbh = db_connect( $db );
  // First, we want to truncate all of the really long entries and
  // strip all of the html/php tags out of it
  $name = truncate_entry( $name, 40 );
  $name = strip_tags( $name );
  $subject = truncate_entry( $subject, 75 );
  $subject = strip_tags( $subject );

  // Figure out which tags we're supposed to strip out of the post
  $query = "select all_html,pre,links,images from config where forum_id = 0";
  $config_res = mysql_query( $query, $dbh );
  if( !$config_res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }
  list( $all_html, $pre, $links, $images ) = mysql_fetch_row( $config_res );
  if( $all_html == 'NO' ) {
    $tags = which_tags( $pre, $links, $images );
    $message = strip_tags( $message, $tags );
  }

  // Form the insert query
  $query = "insert into posts ( parent_id,root_id,name,subject,message,";
  $query .= "hostname,host_ip,computer_info ) values( '$parent', '$root',";
  $query .= " '$name', '$subject', '$message', '$host', '$hostip',";
  $query .= " '$comp_info' )";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    $result = 0;
    db_err( $dbh, "mysql_query: " . $query );
  } else {
    $result = 1;
  }

  return( $result );
}

// --------------------------------------------------------------//
//                         which_tags()                          //
// --------------------------------------------------------------//
// This method figures out which tags are supposed to be stripped//
// out of posts and returns a string containing a comma-delimited//
// string of allowable tags.                                     //
// --------------------------------------------------------------//
function which_tags( $pre, $links, $images ) {
  $tags = "<b>,<i>";
  if( $pre == 'YES' ) {
    $tags .= ",<pre>";
  }
  if( $links == 'YES' ) {
    $tags .= ",<a>";
  }
  if( $images == 'YES' ) {
    $tags .= ",<img>";
  }

  return( $tags );
}

?>