<?php

// --------------------------------------------------------------//
// Written by: Ben Nelson (Venom)                                //
// Last Modified: 03/26/2000                                     //
// Contact Info: venom@venom600.org                              //
//               www.venom600.org                                //
// --------------------------------------------------------------//
// This file contains all of the administrative functionality for//
// VenomBoard.  VenomBoard is a php/MySQL discussion forum that  //
// is fully configureable and quite fast.  The methods in this   //
// file allow the administrator of VenomBoard to delete posts and//
// change options on the board.                                  //
// --------------------------------------------------------------//
// PHP version: 3.0.14                                           //
// Apache Version: 1.3.6                                         //
// SQL system: MySQL 3.22.32                                     //
// --------------------------------------------------------------//

require( "db_misc.php3" );

// --------------------------------------------------------------//
//              print_item( $number, $no_spaces )                //
// --------------------------------------------------------------//
// This method recursively prints out all of the elements beneath//
// itself.                                                       //
// $number = id_num of a post to print                           //
// $no_spaces = number of spaces to print out in front of a      //
//              listing to make threading line up.               //
// --------------------------------------------------------------//
function print_item( $number, $no_spaces ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form the initial query
  $query = "select topic_id,subject,name,create_date";
  $query .= " from posts";
  $query .= " where topic_id = $number";
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked :)
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }


  // Print the proper number of spaces, to make threading look nice
  for( $i = 0; $i < $no_spaces; $i++ ) {
    printf( "&nbsp;" );
  }

  // Get the results of the query and parse the date
  list( $topic_id, $subject, $name, $create_date ) = mysql_fetch_row( $res );
  $printable_date = parse_date( $create_date );

  // Print Subject, name and date
  printf( "- <a href=\"you_sure.php3?id=$topic_id\">$subject</a>" );
  printf( " - posted by $name on $printable_date<br>\n" );

  // Form a new query
  $query = "select topic_id";
  $query .= " from posts";
  $query .= " where parent_id = $number";
  $query .= " order by create_date desc";

  // Send the query to the database
  $res = mysql_query( $query, $dbh );

  // Again, make sure it worked :)
  if(!$res) {
    db_err($dbh, "mysql_query: " . $query);
  }

  // Find out how many rows we are talking about here
  $nr = mysql_numrows($res);

  // Print out post listings for each in number of rows
  if( $nr > 0 ) {
    while( list( $topic_id2 ) = mysql_fetch_row( $res ) ) {
      print_item( $topic_id2, ($no_spaces + 5) );
    }
  }
}

// --------------------------------------------------------------//
//                          print_list()                         //
// --------------------------------------------------------------//
// This method starts the process of printing all of the posts.  //
// --------------------------------------------------------------//
function print_list( $number ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form a query to send to the db backend
  $query = "select topic_id";
  $query .= " from posts";
  $query .= " where parent_id = $number";
  $query .= " order by create_date desc";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  $nr = mysql_numrows( $res );

  if( $nr == 0 ) {
    $return_value = 0;
  } else {
    $return_value = 1;
    while( list( $id ) = mysql_fetch_row( $res ) ) {
      print_item( $id, 0 );
    }
  }
  return( $return_value );
}

// --------------------------------------------------------------//
//                              parse_date()                     //
// --------------------------------------------------------------//
// This method parses out a mysql time stamp into something      //
// readable by humans. :)                                        //
// --------------------------------------------------------------//
function parse_date( $in_date ) {
  $out_date = $in_date[4];
  $out_date .= $in_date[5];
  $out_date .= "/";
  $out_date .= $in_date[6];
  $out_date .= $in_date[7];
  $out_date .= "/";
  $out_date .= $in_date[0];
  $out_date .= $in_date[1];
  $out_date .= $in_date[2];
  $out_date .= $in_date[3];
  $out_date .= " at ";
  $out_date .= $in_date[8];
  $out_date .= $in_date[9];
  $out_date .= ":";
  $out_date .= $in_date[10];
  $out_date .= $in_date[11];

  return( $out_date );
}

// --------------------------------------------------------------//
//                           delete_post()                       //
// --------------------------------------------------------------//
// This method recursively deletes a post and all of its children//
// --------------------------------------------------------------//
function delete_post( $id ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form a query that finds all of the replies to the post 
  $query="select topic_id from posts where parent_id = $id";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure it worked :)
  if(!$res) {
    db_err($dbh, "mysql_query: " . $query);
  }

  // Find out how many rows we are talking about here
  $nr = mysql_numrows($res);

  // Recursively delete each of its children
  if( $nr > 0 ) {
    while( list( $topic_id2 ) = mysql_fetch_row( $res ) ) {
      delete_post( $topic_id2 );
    }
  }

  // After deleting its children delete itself
  $query = "delete from posts where topic_id = $id";

  $res = mysql_query( $query, $dbh );
 
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }
   
}

// --------------------------------------------------------------//
//                     change_format()                           //
// --------------------------------------------------------------//
// This method changes the configuration options in the forum.   //
// --------------------------------------------------------------//
function change_format( $html, $host, $browser, $forum_id ) {
  // Connect to the database
  $dbh = db_connect( $db );

  // Form and send a query to update the show_html config variable
  $query = "update config set show_html = $html where forum_id = $forum_id";
  $res = mysql_query( $query, $dbh );
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  // Form and send a query to update the show_host config variable
  $query = "update config set show_host = $host where forum_id = $forum_id";
  $res = mysql_query( $query, $dbh );
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  // Form and send a query to update the show_browser config variable
  $query = "update config set show_browser = $browser where forum_id = $forum_id";
  $res = mysql_query( $query, $dbh );
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  return( 1 );
}

// --------------------------------------------------------------//
//                     change_host_blocking()                    //
// --------------------------------------------------------------//
// This method determines whether or not to block certain hosts  //
// --------------------------------------------------------------//
function change_host_blocking( $blocking, $forum_id ){
  $dbh = db_connect( $db );

  // Form an update query and send it
  $query = "update config set block_hosts = $blocking where forum_id = $forum_id";
  $res = mysql_query( $query, $dbh );
  if( !$res ) {
    db_err( $dbh, "mysql_query: " . $query );
  }

  return( 1 );
}
 
?>
